# This file is generated by SciPy's build process
# It contains system_info results at the time of building this package.
from enum import Enum

__all__ = ["show"]
_built_with_meson = True


class DisplayModes(Enum):
    stdout = "stdout"
    dicts = "dicts"


def _cleanup(d):
    """
    Removes empty values in a `dict` recursively
    This ensures we remove values that Meson could not provide to CONFIG
    """
    if isinstance(d, dict):
        return { k: _cleanup(v) for k, v in d.items() if v != '' and _cleanup(v) != '' }
    else:
        return d


CONFIG = _cleanup(
    {
        "Compilers": {
            "c": {
                "name": "gcc",
                "linker": r"ld.bfd",
                "version": "13.2.0",
                "commands": r"ccache, cc",
                "args": r"-g, -O2, -fno-omit-frame-pointer, -mno-omit-leaf-frame-pointer, -ffile-prefix-map=/usr/src/packages/BUILD=., -flto=auto, -ffat-lto-objects, -fstack-protector-strong, -fstack-clash-protection, -Wformat, -Werror=format-security, -fcf-protection, -fdebug-prefix-map=/usr/src/packages/BUILD=/usr/src/python-scipy-100:1.13.0-1, -Wdate-time, -D_FORTIFY_SOURCE=3",
                "linker args": r"-Wl,-Bsymbolic-functions, -flto=auto, -ffat-lto-objects, -Wl,-z,relro, -g, -O2, -fno-omit-frame-pointer, -mno-omit-leaf-frame-pointer, -ffile-prefix-map=/usr/src/packages/BUILD=., -flto=auto, -ffat-lto-objects, -fstack-protector-strong, -fstack-clash-protection, -Wformat, -Werror=format-security, -fcf-protection, -fdebug-prefix-map=/usr/src/packages/BUILD=/usr/src/python-scipy-100:1.13.0-1, -Wdate-time, -D_FORTIFY_SOURCE=3",
            },
            "cython": {
                "name": r"cython",
                "linker": r"cython",
                "version": r"3.0.10",
                "commands": r"cython",
                "args": r"",
                "linker args": r"",
            },
            "c++": {
                "name": "gcc",
                "linker": r"ld.bfd",
                "version": "13.2.0",
                "commands": r"ccache, c++",
                "args": r"-g, -O2, -fno-omit-frame-pointer, -mno-omit-leaf-frame-pointer, -ffile-prefix-map=/usr/src/packages/BUILD=., -flto=auto, -ffat-lto-objects, -fstack-protector-strong, -fstack-clash-protection, -Wformat, -Werror=format-security, -fcf-protection, -fdebug-prefix-map=/usr/src/packages/BUILD=/usr/src/python-scipy-100:1.13.0-1, -Wdate-time, -D_FORTIFY_SOURCE=3",
                "linker args": r"-Wl,-Bsymbolic-functions, -flto=auto, -ffat-lto-objects, -Wl,-z,relro, -g, -O2, -fno-omit-frame-pointer, -mno-omit-leaf-frame-pointer, -ffile-prefix-map=/usr/src/packages/BUILD=., -flto=auto, -ffat-lto-objects, -fstack-protector-strong, -fstack-clash-protection, -Wformat, -Werror=format-security, -fcf-protection, -fdebug-prefix-map=/usr/src/packages/BUILD=/usr/src/python-scipy-100:1.13.0-1, -Wdate-time, -D_FORTIFY_SOURCE=3",
            },
            "fortran": {
                "name": "gcc",
                "linker": r"ld.bfd",
                "version": "13.2.0",
                "commands": r"gfortran",
                "args": r"-g, -O2, -fno-omit-frame-pointer, -mno-omit-leaf-frame-pointer, -ffile-prefix-map=/usr/src/packages/BUILD=., -flto=auto, -ffat-lto-objects, -fstack-protector-strong, -fstack-clash-protection, -fcf-protection, -fdebug-prefix-map=/usr/src/packages/BUILD=/usr/src/python-scipy-100:1.13.0-1",
                "linker args": r"-Wl,-Bsymbolic-functions, -flto=auto, -ffat-lto-objects, -Wl,-z,relro, -g, -O2, -fno-omit-frame-pointer, -mno-omit-leaf-frame-pointer, -ffile-prefix-map=/usr/src/packages/BUILD=., -flto=auto, -ffat-lto-objects, -fstack-protector-strong, -fstack-clash-protection, -fcf-protection, -fdebug-prefix-map=/usr/src/packages/BUILD=/usr/src/python-scipy-100:1.13.0-1",
            },
            "pythran": {
                "version": r"0.15.0",
                "include directory": r"../../../../lib/python3/dist-packages/pythran"
            },
        },
        "Machine Information": {
            "host": {
                "cpu": r"x86_64",
                "family": r"x86_64",
                "endian": r"little",
                "system": r"linux",
            },
            "build": {
                "cpu": r"x86_64",
                "family": r"x86_64",
                "endian": r"little",
                "system": r"linux",
            },
            "cross-compiled": bool("False".lower().replace('false', '')),
        },
        "Build Dependencies": {
            "blas": {
                "name": "openblas",
                "found": bool("True".lower().replace('false', '')),
                "version": "0.3.26",
                "detection method": "pkgconfig",
                "include directory": r"/usr/include/x86_64-linux-gnu/openblas-pthread/",
                "lib directory": r"/usr/lib/x86_64-linux-gnu/openblas-pthread/",
                "openblas configuration": r"USE_64BITINT=0 DYNAMIC_ARCH=1 DYNAMIC_OLDER=1 NO_CBLAS= NO_LAPACK= NO_LAPACKE=1 NO_AFFINITY=1 USE_OPENMP=0 generic MAX_THREADS=64",
                "pc file directory": r"/usr/lib/x86_64-linux-gnu/pkgconfig",
            },
            "lapack": {
                "name": "openblas",
                "found": bool("True".lower().replace('false', '')),
                "version": "0.3.26",
                "detection method": "pkgconfig",
                "include directory": r"/usr/include/x86_64-linux-gnu/openblas-pthread/",
                "lib directory": r"/usr/lib/x86_64-linux-gnu/openblas-pthread/",
                "openblas configuration": r"USE_64BITINT=0 DYNAMIC_ARCH=1 DYNAMIC_OLDER=1 NO_CBLAS= NO_LAPACK= NO_LAPACKE=1 NO_AFFINITY=1 USE_OPENMP=0 generic MAX_THREADS=64",
                "pc file directory": r"/usr/lib/x86_64-linux-gnu/pkgconfig",
            },
            "pybind11": {
                "name": "pybind11",
                "version": "2.12.0",
                "detection method": "pkgconfig",
                "include directory": r"/include",
            },
        },
        "Python Information": {
            "path": r"/usr/bin/python3",
            "version": "3.12",
        },
    }
)


def _check_pyyaml():
    import yaml

    return yaml


def show(mode=DisplayModes.stdout.value):
    """
    Show libraries and system information on which SciPy was built
    and is being used

    Parameters
    ----------
    mode : {`'stdout'`, `'dicts'`}, optional.
        Indicates how to display the config information.
        `'stdout'` prints to console, `'dicts'` returns a dictionary
        of the configuration.

    Returns
    -------
    out : {`dict`, `None`}
        If mode is `'dicts'`, a dict is returned, else None

    Notes
    -----
    1. The `'stdout'` mode will give more readable
       output if ``pyyaml`` is installed

    """
    if mode == DisplayModes.stdout.value:
        try:  # Non-standard library, check import
            yaml = _check_pyyaml()

            print(yaml.dump(CONFIG))
        except ModuleNotFoundError:
            import warnings
            import json

            warnings.warn("Install `pyyaml` for better output", stacklevel=1)
            print(json.dumps(CONFIG, indent=2))
    elif mode == DisplayModes.dicts.value:
        return CONFIG
    else:
        raise AttributeError(
            f"Invalid `mode`, use one of: {', '.join([e.value for e in DisplayModes])}"
        )
